models/Peliculas.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "peliculas".
 *
 * @property int $id
 * @property string|null $titulo
 * @property string|null $descripcion
 * @property int|null $duracion
 * @property string|null $fecha_estreno
 * @property string|null $categoria
 * @property string|null $portada
 * @property string|null $director
 * @property int|null $destacada
 * @property int|null $peliculaSemana
 */
class Peliculas extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'peliculas';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['duracion', 'destacada', 'peliculaSemana'], 'integer'],
            [['fecha_estreno'], 'safe'],
            [['titulo', 'descripcion', 'categoria', 'portada', 'director'], 'string', 'max' => 100],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'titulo' => 'Titulo',
            'descripcion' => 'Descripcion',
            'duracion' => 'Duracion',
            'fecha_estreno' => 'Fecha Estreno',
            'categoria' => 'Categoria',
            'portada' => 'Portada',
            'director' => 'Director',
            'destacada' => 'Destacada',
            'peliculaSemana' => 'Pelicula Semana',
        ];
    }
}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use app\models\Peliculas;
use yii\data\ActiveDataProvider;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        $pelicula= Peliculas::find()
                ->where(['peliculaSemana'=>1])
                ->one();
        return $this->render('index',[
            'pelicula' => $pelicula->portada,
            'id' => $pelicula->id,
        ]);
    }
    
    public function actionListado() {
        $dataProvider = new ActiveDataProvider([
            "query" => Peliculas::find(),
        ]);
                
        return $this->render('listado',[
            'dataProvider' => $dataProvider,
        ]);        
    }
    
    public function actionCategorias() {
        $dataProvider = new ActiveDataProvider([
            "query" => Peliculas::find()->select('categoria')->distinct(),
        ]);
                
        return $this->render('categorias',[
            'dataProvider' => $dataProvider,
        ]);        
    }
    
    public function actionDestacadas() {
        $dataProvider = new ActiveDataProvider([
            "query" => Peliculas::find()->where(['destacada'=>1]),
        ]);
                
        return $this->render('destacadas',[
            'dataProvider' => $dataProvider,
        ]);        
    }
    
    /**
     * accion que me muestra la pelicula sobre la que he realizado clic
     * en la pagina de inicio
     */
    public function actionVerpelicula($id) {
        $pelicula = Peliculas::findOne($id);
        
        return $this->render("verPelicula",[
            "pelicula" => $pelicula
        ]);
    }
    
    
    /**
     * Accion que me muestra las peliculas de una determinada categoria
     * seleccionada en la viata _categoria
     * @param type $categoria categoria seleccionada
     * @return vista donde me va a mostrar las peliculas
     */
    public function actionVer($categoria) {
        $dataProvider = new ActiveDataProvider([
            'query' => Peliculas::find()->where(['categoria'=>$categoria]),
         ]);   
        
        return $this->render("ver",[
            'dataProvider' => $dataProvider
            ]);    
    }
    
    
    /**
     * Accion que me muestra las peliculas de una determinada categoria
     * seleccionada en la vista listado
     * @param type $id ide de la pelicula seleccionada
     * @return vista vergrid que me muestra las peliculas de la categoria de peliculas seleccionada
     */
    public function actionVergrid($id) { // me llega un 1
        
        // saco la categoria de la pelicula sobre la que he realizado clic (se envia la id)
        $categoria=Peliculas::findOne($id)->categoria;
        
        $dataProvider = new ActiveDataProvider([
            'query' => Peliculas::find()->where(['categoria'=>$categoria]),
        ]);
                
        return $this->render("vergrid",[
            'dataProvider' => $dataProvider
         ]);            
    }
}    

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header>
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'brandImage' => '@web/imgs/logo.jpg',
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'items' => [
            ['label' => 'Inicio', 'url' => ['/site/index']],
            ['label' => 'Listado', 'url' => ['/site/listado']],
            ['label' => 'Categorias', 'url' => ['/site/categorias']],
            ['label' => 'Destacadas', 'url' => ['/site/destacadas']],
        ],
    ]);
    NavBar::end();
    ?>
</header>

<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer class="footer mt-auto py-3 text-muted">
    <div class="container">
        <p class="float-left">Pedro J. Ejemplo 006 YII</p>
        <p class="float-right">Alpe Formacion</p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/_categorias.php
<?php
    use yii\helpers\Html;
    
?>
  <ul class="list-group list-group-flush">
    <li class="list-group-item">Categoria: <?= $model->categoria?></li>
    <li class="list-group-item">
                <?= Html::a('Ver mas ...', 
                        ['site/ver', 'categoria' => $model->categoria], 
                        ['class' => 'btn btn-primary']) ?>
    </li>
  </ul>

views/site/_destacada.php
<?php

use yii\helpers\Html;
?>
<div class="row">
    <div class="col-lg-4">
    <?php
echo Html::img("@web/imgs/$model->portada", [
    "class" => "card-img-top"
    ]);
?>
</div>
    <div class="col-lg-8">
        <h2><?= $model->titulo ?><br></h2>
        Duracion:<br>
        <?= $model->duracion ?> minutos<br>
        Director:<br>
        <?= $model->director ?><br>
        Categoria:
        <?= $model->destacada ?><br><br>
        <?=
            Html::a('Ver mas ...', 
                ['site/verpelicula', 'id' => $model->id], 
                ['class' => '']) 
        ?><br>
    </div>
</div>

views/site/_ver.php
<?php

use yii\helpers\Html;
?>
<div class="row">
    <div class="col-lg-4">
    <?php
echo Html::img("@web/imgs/$model->portada", [
    "class" => "card-img-top"
    ]);
?>
</div>
    <div class="col-lg-8">
        <h2><?= $model->titulo ?><br></h2>
        Duracion:<br>
        <?= $model->duracion ?> minutos<br>
        Director:<br>
        <?= $model->director ?><br><br>
        <?=
            Html::a('Ver mas ...', 
                ['site/verpelicula', 'id' => $model->id], 
                ['class' => '']) 
        ?><br>
    </div>
</div>

views/site/categorias.php
<?php

use \yii\widgets\ListView;

echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView'=>'_categorias',
    'itemOptions'=>['class' => 'card'],
    'options'=> ['class' => 'card-colums'],
    'layout' => "{items}"
]);

views/site/destacadas.php
<?php
use \yii\widgets\ListView;

echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView'=>'_destacada',
    'itemOptions'=>['class' => 'col-lg-6'],
    'options'=> ['class' => 'row'],
    'layout' => "{items}"
]);

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/* @var $this yii\web\View */
use yii\helpers\Html;

$this->title = 'My Yii Application';
?>
<div class="site-index">

    <div class="body-content">

        <div class="row">
            <div class="col-lg-8 text-justify">
                <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.
                Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.
                Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.</p>

            </div>
            <div class="col-lg-8 text-center">
                <h2>Pelicula de la semana</h2>
                
            <?= 
            Html::a(
                Html::img("@web/imgs/$pelicula",[
                        "class" => "img-fluid",
                        ]),
                      ["site/verpelicula","id"=>$id],
                      ['class' => ''],
                      );  
            ?>
            </div>    
        </div>

    </div>
</div>

views/site/listado.php
<?php

use yii\grid\GridView;
use yii\helpers\Html;


echo GridView::widget([
    'dataProvider' => $dataProvider,
    'columns' => [
        'id',
        'titulo',
        [
            'label'=>'Categoria', // el nombre del campo de la base de datos
            'format'=>'raw',
            'value' => function($data){
                return Html::a(
                        $data->categoria,
                        ['site/vergrid',"id"=>$data->id],
                        ["class"=> 'btn btn-info']); 
            }
        ],
        'fecha_estreno',
        [
            'label'=>'Portada',
            'format'=>'raw',
            'value' => function($data){
                $url = '@web/imgs/' . $data->portada;
                return Html::img($url,[
                    'class'=>'img-fluid',
                    'style'=> 'width:205px']); 
            }
        ],
    ],
]);

views/site/ver.php
<?php
use \yii\widgets\ListView;

echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView'=>'_ver',
    'itemOptions'=>['class' => 'col-lg-6'],
    'options'=> ['class' => 'row'],
    'layout' => "{items}"
]);

views/site/verPelicula.php
<?php

use yii\widgets\DetailView;
use yii\helpers\Html;

echo DetailView::widget([
    'model' => $pelicula,
    'attributes' => [
        'id',
        'titulo',
        'descripcion',
        'duracion',
        'fecha_estreno',
        'categoria',
        'director',
        'destacada',
        'peliculaSemana',
        [
            'label'=>'foto', // el nombre del campo de la base de datos
            'format'=>'raw',
            'value' => function($data){
                $url = '@web/imgs/' . $data->portada;
                return Html::img($url,[
                    'class'=>'img-fluid',
                    'style'=> 'width:205px']); 
            }
        ],
    ]
]);

views/site/vergrid.php
<?php

use yii\grid\GridView;
use yii\helpers\Html;
echo GridView::widget([
    'dataProvider' => $dataProvider,
    'columns' => [
        'id',
        'titulo',
        'fecha_estreno',
        [
            'label'=>'foto', // el nombre del campo de la base de datos
            'format'=>'raw',
            'value' => function($data){
                $url = '@web/imgs/' . $data->portada;
                return Html::img($url,[
                    'class'=>'img-fluid',
                    'style'=> 'width:200px']); 
            }
        ],
    ]
]);
        